package ru.ldeloff.servermonitorbot.init;

import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.boot.ApplicationArguments;
import org.springframework.boot.ApplicationRunner;
import org.springframework.core.annotation.Order;
import org.springframework.stereotype.Component;
import org.telegram.telegrambots.meta.api.methods.send.SendMessage;
import ru.ldeloff.servermonitorbot.service.MessagingService;
import ru.ldeloff.servermonitorbot.service.UserService;
import ru.ldeloff.servermonitorbot.view.TelegramBotKeyboard;

@Slf4j
@Component
@RequiredArgsConstructor
@Order(3)
public class ReloadNotification implements ApplicationRunner {

    private final TelegramBotKeyboard telegramBotKeyboard;
    private final MessagingService messagingService;
    private final UserService userService;

    @Override
    public void run(ApplicationArguments args) {
        userService.getAllUsers().forEach(user -> {
            SendMessage sendMessage = new SendMessage();
            sendMessage.setChatId(user.getTelegramId());
            sendMessage.setText("Бот перезапущен");
            messagingService.send(telegramBotKeyboard.uiForm(sendMessage));
        });
    }
}
